%define kmodtool sh %{SOURCE49}
%define	kmod_name xenpv
%define kverrel %(%{kmodtool} verrel 2>/dev/null)

# hardcode for now (rhel4)
%define kvariants ""
%define kbuilddep kernel-devel = %{kverrel}

%ifarch i686
%define kvariants "" smp hugemem
%define kbuilddep kernel-devel = %{kverrel} kernel-smp-devel = %{kverrel} kernel-hugemem-devel = %{kverrel}
%endif

%ifarch x86_64
%define kvariants "" smp largesmp
%define kbuilddep kernel-devel = %{kverrel} kernel-smp-devel = %{kverrel} kernel-largesmp-devel = %{kverrel}
%endif

%ifarch ia64
%define kvariants "" largesmp
%define kbuilddep kernel-devel =%{kverrel} kernel-largesmp-devel = %{kverrel}
%endif

%define xen_src_rev 3.1.0 

Name: xenpv
License: GPL
Group: System/Kernel
Summary: xen paravirtual drivers
Version: 0.1
Release: 10.0.2.el4
Source0: xen-%{xen_src_rev}-src.tgz
Source1: xenpv.modprobe
Source3: README.el4
# ia64 xen-vnif crashes domU in net-poll at this time
# ExclusiveArch:	i686 x86_64 ia64
# patch ia64-netfront fixes this problem
ExclusiveArch:	i686 x86_64 ia64

# rhel-4 only
Source40: xenpv.rhel4.hotplug.agent
Source49: xenpv-kmodtool-el4

# rhel-5 fixes
Patch1:  %name-buildfix.patch
Patch2:  %name-nosysfs.patch
Patch3:  %name-noxen.patch
Patch4:  %name-initrace.patch
# remove patch5 if rebase to xen-3.1.2
Patch5:  %name-smprace.patch
Patch6:  %name-skb-useafterfree.patch
Patch7:  %name-ia64-balloon.patch
Patch8:  %name-ia64-isairq.patch
Patch9:  %name-netfront-pae.patch
# remove patch18 if rebase to xen-3.1.2
Patch18: %name-evtchn-unbind.patch

# for newer and older kernels (rhel4)
Patch10:  %name-knl269.patch
Patch11:  %name-declare-work.patch
Patch12:  %name-no-config-h.patch
Patch13:  %name-knl2623.patch
Patch14:  %name-signal-guest-panic.patch
Patch15:  %name-kzalloc-watch.patch

# ressource allocation bits
# Patch20:  %name-res-rtl8139.patch
# Patch21:  %name-res-piix.patch

# module autoloading
Patch30:  %name-autoload.patch

# rhel-4 only
Patch40:  %name-rhel4-backports.patch
Patch41:  %name-ia64-netfront.patch
Patch42:  %name-el4u6-pvhvm-migration-hang-7442030.patch

# OVS bug fixes
Patch50:  ovs-bugz7258-pvhvm-netfront.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: %{name}-kmod
Provides: %{name}-kmod-common
BuildRequires: kernel = %{kverrel} %kbuilddep

%description
xen paravirtual drivers for Linux Full-Virt/HVM guests

%define kmp_version %{version}
%define kmp_release %{release}
%{expand:%(%{kmodtool} rpmtemplate_kmp xenpv %{kverrel} %{kvariants} 2>/dev/null)}

%prep
%setup -q -c

cd xen-%{xen_src_rev}-src

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch18 -p1

%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
#%patch20 -p1
#%patch21 -p1
%patch30 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1

# OVS bug fixes
%patch50 -p3

set -- *
mkdir source
mv "$@" source/

%build
cd xen-%{xen_src_rev}-src
for flavor in %kvariants; do
	echo "### building for $flavor kernel ###"
	mdir="obj-$flavor/unmodified_drivers/linux-2.6"
	ksrc=%{_usrsrc}/kernels/%{kverrel}${flavor:+-$flavor}-%{_target_cpu}
	rm -rf obj-$flavor
	cp -r source obj-$flavor
	(cd $mdir; ./mkbuildtree)
	make %{?_smp_mflags} -C $ksrc M=$PWD/$mdir modules
#	make V=1 %{?_smp_mflags} -C $ksrc M=$PWD/$mdir modules
done

%install
rm -rf %{buildroot}
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=extra/%{name}/%{version}-%{release}
cd xen-%{xen_src_rev}-src
for flavor in %kvariants; do
	mdir="obj-$flavor/unmodified_drivers/linux-2.6"
	ksrc=%{_usrsrc}/kernels/%{kverrel}${flavor:+-$flavor}-%{_target_cpu}
	make -C $ksrc M=$PWD/$mdir modules_install
#	make V=1 -C $ksrc M=$PWD/$mdir modules_install
	# INSTALL_MOD_DIR not working yet in that kernel version ...
	fix="%{buildroot}/lib/modules/%{kverrel}${flavor}"
	mkdir -p $fix/$INSTALL_MOD_DIR
	mv -v $fix/extra/*.ko $fix/$INSTALL_MOD_DIR
	# module names are different on pv kernel vs. native kernel +
	# pv-on-hvm drivers.  symlink to trick kmodule and kudzu.
	ln -s xen-vbd.ko $fix/$INSTALL_MOD_DIR/xenblk.ko
	ln -s xen-vnif.ko $fix/$INSTALL_MOD_DIR/xennet.ko
done
mkdir -p %{buildroot}/etc/modprobe.d
cp -v %{SOURCE1} %{buildroot}/etc/modprobe.d/xenpv
mkdir -p %{buildroot}/etc/hotplug
cp -v %{SOURCE40} %{buildroot}/etc/hotplug/xen.agent
mkdir -p %{buildroot}/usr/share/doc/%{name}-%{version}-%{release}
cp -v %{SOURCE3} %{buildroot}/usr/share/doc/%{name}-%{version}-%{release}/README

#%files
#%defattr(-,root,root)
#%config(noreplace) /etc/modprobe.d/xenpv
#%doc /usr/share/doc/%{name}-%{version}-%{release}/README
#%attr(755,root,root) /etc/hotplug/xen.*

%changelog
* Thu Oct 23 2008 Kevin Lyons <kevin.x.lyons@oracle.com> - 0.1-10.0.2.el4
- Add patch to add polling support to netfront driver (tina.yang@oracle.com> [bugz 7258]

* Thu Sep 25 2008 Chuck Anderson <chuck.anderson@oracle.com> - 0.1-10.0.1.el4
- fix el4u6 pvhvm guest migration hang Oracle bug 7442030

* Wed Feb 27 2008 Don Dutile <ddutile@dddesktop0.boston.redhat.com> - 0.1-7.el4
- add netfront patch for ia64

* Fri Sep 21 2007 Don Dutile <ddutile@dddesktop0.boston.redhat.com> - 0.1-1
- First Version based on Gerd's -35 mercurial tree
  and first rev. of RHEL-5-kmod cvs/dist xenpv.spec

